package com.example.samodelkin

import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import com.example.samodelkin.databinding.ActivityMainBinding
import kotlinx.coroutines.launch
import kotlinx.coroutines.*

private const val CHARACTER_DATA_KEY = "CHARACTER_DATA_KEY"

private var Bundle.characterData
    get() = getSerializable(CHARACTER_DATA_KEY) as CharacterGenerator.CharacterData
    set(value) = putSerializable(CHARACTER_DATA_KEY, value)

class MainActivity : AppCompatActivity() {
    private var characterData = CharacterGenerator.generate()

    override fun onSaveInstanceState(savedInstanceState: Bundle) {
        super.onSaveInstanceState(savedInstanceState)
        savedInstanceState.characterData = characterData
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        //setContentView(R.layout.activity_main)

        val binding = ActivityMainBinding.inflate(layoutInflater)
        val view = binding.root
        setContentView(view)

        characterData = savedInstanceState?.characterData ?:
                CharacterGenerator.generate()

        binding.generateButton.setOnClickListener {
//            characterData = CharacterGenerator.//generate()
//                    fromApiData("halfling,Lars Kizzy,14,13,8")
            GlobalScope.launch()  {
                characterData = fetchCharacterDataAsync().await()
            }
            displayCharacterData(binding)
        }
        displayCharacterData(binding)
    }


    private fun displayCharacterData(binding: ActivityMainBinding) {
        characterData.run {
            binding.nameTextView.text = name
            binding.raceTextView.text = race
            binding.dexterityTextView.text = dex
            binding.wisdomTextView.text = wis
            binding.strengthTextView.text = str
        }
    }
}